/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: clearchan
 * CMDLEVEL: QCMD_AUTHED
 * CMDARGS: 1
 * CMDDESC: Removes all modes from a channel.
 * CMDFUNC: csc_doclearchan
 * CMDPROTO: int csc_doclearchan(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: CLEARCHAN <channel>
 * CMDHELP: Removes all channel modes (such as keys, limits, invite only, etc.) from
 * CMDHELP: the named channel.  Modes being enfored (see CHANMODE) will not be removed.
 * CMDHELP: Where:
 * CMDHELP: channel - channel to remove modes from
 * CMDHELP: CLEARCHAN requires master (+m) access on the named channel.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_doclearchan(void *source, int cargc, char **cargv) {
  nick *sender=source;
  chanindex *cip;
  modechanges changes;
  
  if (cargc<1) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "clearchan");
    return CMD_ERROR;
  }

  if (!(cip=cs_checkaccess(sender, cargv[0], CA_MASTERPRIV, NULL, "clearchan",0, 0)))
    return CMD_ERROR;

  if (cip->channel) {
    localsetmodeinit(&changes, cip->channel, chanservnick);
    localdosetmode_key(&changes, NULL, MCB_DEL);
    localdosetmode_simple(&changes, 0, cip->channel->flags);
    cs_docheckchanmodes(cip->channel, &changes);
    localsetmodeflush(&changes, 1);
  }

  cs_log(sender,"CLEARCHAN %s",cip->name->content);
  chanservstdmessage(sender, QM_DONE);
  return CMD_OK;
}     
