/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: renchan
 * CMDLEVEL: QCMD_OPER
 * CMDARGS: 3
 * CMDDESC: Renames a channel on the bot.
 * CMDFUNC: csc_dorenchan
 * CMDPROTO: int csc_dorenchan(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: renchan <old channel> <new channel>
 * CMDHELP: Moves the bot from one channel to another, preserving flags.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_dorenchan(void *source, int cargc, char **cargv) {
  nick *sender=source;
  reguser *rup=getreguserfromnick(sender);
  chanindex *cip1,*cip2;
  regchan *rcp;

  if (!rup)
    return CMD_ERROR;

  if (cargc<2) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "renchan");
    return CMD_ERROR;
  }

  if (!(cip1=findchanindex(cargv[0])) || !(rcp=cip1->exts[chanservext])) {
    chanservstdmessage(sender, QM_UNKNOWNCHAN, cargv[0]);
    return CMD_ERROR;
  }

  if (*cargv[1] != '#') {
    chanservstdmessage(sender, QM_INVALIDCHANNAME, cargv[0]);
    return CMD_ERROR;
  } 

  if (!(cip2=findorcreatechanindex(cargv[1])) || cip2->exts[chanservext]) {
    chanservstdmessage(sender, QM_ALREADYREGISTERED, cip2->name->content);
    return CMD_ERROR;
  }

  cs_log(sender,"RENCHAN %s -> %s",cip1->name->content,cip2->name->content);

  /* Remove from the channel.  Don't bother if the channel doesn't exist. */
  if (!CIsSuspended(rcp) && cip1->channel) {
    CSetSuspended(rcp);    
    chanservjoinchan(cip1->channel);
    CClearSuspended(rcp);
  }
  
  cip1->exts[chanservext]=NULL;
  releasechanindex(cip1);

  cip2->exts[chanservext]=rcp;
  rcp->index=cip2;
  if (cip2->channel) {
    chanservjoinchan(cip2->channel);
  }

  csdb_updatechannel(rcp);
  chanservstdmessage(sender, QM_DONE);

  return CMD_OK;
}
