/*
 * name functionality 
 */

#include "newsearch.h"

#include <stdio.h>
#include <stdlib.h>

void *name_exe(searchCtx *ctx, struct searchNode *thenode, void *theinput);
void name_free(searchCtx *ctx, struct searchNode *thenode);

struct searchNode *name_parse(searchCtx *ctx, int argc, char **argv) {
  struct searchNode *thenode;

  if (!(thenode=(struct searchNode *)malloc(sizeof(struct searchNode)))) {
    /* couldn't malloc() memory for thenode, so free localdata to avoid leakage */
    parseError = "malloc: could not allocate memory for this search.";
    return NULL;
  }

  thenode->returntype = RETURNTYPE_STRING;
  thenode->localdata = NULL;
  thenode->exe = name_exe;
  thenode->free = name_free;

  return thenode;
}

void *name_exe(searchCtx *ctx, struct searchNode *thenode, void *theinput) {
  chanindex *cip = (chanindex *)theinput;

  return cip->name->content;
}

void name_free(searchCtx *ctx, struct searchNode *thenode) {
  free(thenode);
}

